import os
import tarfile

from charmhelpers.core.files import sed
from charmhelpers.payload.archive import extract
from charmhelpers.fetch.archiveurl import ArchiveUrlFetchHandler
from nexentaedge.settings import Settings
from charmhelpers.core.hookenv import log


def neadm_bundles_copy():

    install_dir = Settings.NEDGE_FOLDER_PATH

    # create dest folder
    if not os.path.exists(install_dir):
        os.makedirs(install_dir)

    installer = ArchiveUrlFetchHandler()
    installer.install(Settings.NEDEPLOY_REPO_PATH,
                      install_dir)

    installer.install(Settings.NEADM_REPO_PATH,
                      install_dir)

    log("Build version is {0}".format(Settings.NEDGE_BUILD_NUMBER))
    if (int(Settings.NEDGE_BUILD_NUMBER) < 2014):
        log("Do the patch...")
        do_chef_metadata_fix()


def do_chef_metadata_fix():

    #chef metadata condition fix, should work for builds <= 2014
    #extract nedge solo archive
    solo_archive_name = 'nedge-solo.tar.gz'

    solo_libnedeploy_path = os.path.join(Settings.NEDEPLOY_FOLDER_PATH,
                                         'libnedeploy')
    solo_archive_path = os.path.join(solo_libnedeploy_path,
                                     solo_archive_name)

    log("Extract {0} to {1}"
        .format(solo_libnedeploy_path, solo_libnedeploy_path))
    extract(solo_archive_path, solo_libnedeploy_path)

    #fix script by replacing md5 to sha1
    script_path = os.path.join(solo_libnedeploy_path,
                               'nedge-chef-solo',
                               'install.sh')

    log("Patching {}".format(script_path))
    sed(script_path,
        "grep '\^md5'",
        "grep '\^sha1'")

    #tar fixed
    source = os.path.join(solo_libnedeploy_path,
                          'nedge-chef-solo')
    log("Creating archive {0} from {1}".format(solo_archive_path, source))
    make_tarfile(solo_archive_path, source)


def make_tarfile(output_filename, source_dir):
    with tarfile.open(output_filename, "w:gz") as tar:
        tar.add(source_dir, arcname=os.path.basename(source_dir))
